/* lw-support/src/lib/Enums/IOMode.h
 *
 *  (c)2005, Laurence Withers. Released under the GNU GPL. See file
 *  COPYING for more information / terms of license.
*/

namespace lw {

/*! \brief I/O open modes.

This enumeration represents what a device is opened for; reading,
writing, both or neither. It also has a member to report that the
device isn't open at all.

*/
enum IOMode {
    /// Device isn't open.
    IOClosed,

    /// Device was opened in non-read, non-write mode.
    IONone,

    /// Device is read only.
    IORead,

    /// Device is write only.
    IOWrite,

    /// Device is read/write.
    IOReadWrite
};

}
