/* lw-support/src/lib/Enums/ISO8601Format.h
 *
 *  (c)2005, Laurence Withers. Released under the GNU GPL. See file
 *  COPYING for more information / terms of license.
*/

namespace lw {



/// Denotes the different formats accepted for ISO8601 dates.
enum ISO8601Format {
    ISO8601FormatDetect, ///< Used to autodetect format when reading.
    ISO8601FormatCalendar, ///< yyyymmdd
    ISO8601FormatOrdinal, ///< yyyyddd
    ISO8601FormatWeekDate ///< yyyyWwwd
};



/// Allows you to specify precision when converting to ISO8601 format.
enum ISO8601Precision {
    ISO8601PrecisionFull, ///< Converts everything.
    ISO8601PrecisionYear, ///< Only converts year.
    ISO8601PrecisionWeek, ///< Converts year and week.
    ISO8601PrecisionMonth, ///< Converts year and month.
    ISO8601PrecisionDay, ///< Converts year, month and day.
    ISO8601PrecisionHour, ///< Converts date and hour.
    ISO8601PrecisionMinute, ///< Converts date, hour and minute.
    ISO8601PrecisionSecond ///< Converts date and time.
};



}
