/* lw-support/src/lib/Events/CallbackIO.h
 *
 *  (c)2005, Laurence Withers. Released under the GNU GPL. See file
 *  COPYING for more information / terms of license.
*/

namespace lw {



/// I/O event callback object.
class EventCallbackIO {
public:
    /// Destructor. Does nothing.
    virtual ~EventCallbackIO()
    { }

    /*! \brief I/O ready callback.

    \param flags A bitfield of events that have occurred.

    This function is called when the device it is associated with becomes ready for I/O. The details
    will be indicated through the \a flags argument, which is a bitfield of:
     - IOEventRead
     - IOEventWrite
     - IOEventUrgent
     - IOEventError
     - IOEventHUP

    Note that you cannot call any lw::EventManager functions within this callback, with the
    exception of modifyDevice().

    */
    virtual void ioReady(uint32_t flags) throw() = 0;
};



}

/* options for text editors
kate: replace-trailing-space-save true; space-indent true; tab-width 4;
*/
