/* lw-support/src/lib/Events/CallbackTimer.h
 *
 *  (c)2005, Laurence Withers. Released under the GNU GPL. See file
 *  COPYING for more information / terms of license.
*/

namespace lw {



/// Timer event callback object.
class EventCallbackTimer {
public:
    /// Destructor. Does nothing.
    virtual ~EventCallbackTimer()
    { }



    /*! \brief Timer event callback.

    \param key The key of the timer event.

    This function is called whenever a timer event expires. It must not throw any exceptions. The
    value of \a key is the value returned when you initially registered the timer.

    */
    virtual void timer(Key key) throw() = 0;
};



}

/* options for text editors
kate: replace-trailing-space-save true; space-indent true; tab-width 4;
*/
