/* lw-support/src/lib/Exceptions/BadArgument.cpp
 *
 *  (c)2006, Laurence Withers. Released under the GNU GPL. See file COPYING for more information
 *  and terms of license, or read http://www.gnu.org/copyleft/gpl.html .
*/

namespace lw {



BadArgument::BadArgument(const std::wstring& argName, const std::wstring& acceptableRange,
                         const std::wstring& value)
    : Exception(format(argName, acceptableRange, value)), argName(argName),
    acceptableRange(acceptableRange), value(value)
{
}



std::wstring BadArgument::format(const std::wstring& argName, const std::wstring& acceptableRange,
                                 const std::wstring& value)
{
    std::wostringstream ostr;
    ostr << "Invalid argument to function."
        "\n  Argument name   : " << argName <<
        "\n  Acceptable range: " << acceptableRange <<
        "\n  Actual value    : " << value;
    return ostr.str();
}



}

/* options for text editors
kate: replace-trailing-space-save true; space-indent true; tab-width 4;
*/
