/* lw-support/src/lib/Exceptions/DNS.cpp
 *
 *  (c)2005, Laurence Withers. Released under the GNU GPL. See file
 *  COPYING for more information / terms of license.
*/

namespace lw {



std::wstring DnsError::buildDesc(const std::wstring& reason,
    const std::string& host)
{
    std::wostringstream o;
    o << L"DNS operation failed.\n"
         L"  Description: " << reason << L"\n"
         L"  Host       : " << utf8ToUcs4(host, true);
    return o.str();
}



DnsError::DnsError(const std::wstring& reason, const std::string& host)
    : Exception(buildDesc(reason, host)),
      reason(reason), host(host)
{
}



}
