/* lw-support/src/lib/Exceptions/Exception.cpp
 *
 *  (c)2005, Laurence Withers. Released under the GNU GPL. See file
 *  COPYING for more information / terms of license.
*/

namespace lw {



Exception::Exception(const std::wstring& errorDesc)
    : errorDesc(errorDesc), whatBuffer(0)
{
}



Exception::~Exception() throw()
{
    free(whatBuffer);
}



Exception& Exception::chain(const std::wstring& chainDesc)
{
    errorDesc.append(L"\n From: ");
    errorDesc.append(chainDesc);
    return *this;
}



const char* Exception::what() const throw()
{
    free(whatBuffer);
    whatBuffer = strdup(toUtf8().c_str());
    return whatBuffer ?: "Couldn't allocate memory for exception conversion.";
}



std::string Exception::toUtf8() const
{
    try {
        return ucs4ToUtf8(errorDesc);
    }
    catch(...) {
        return "Couldn't encode exception text into UTF-8.";
    }
}



std::wostream& operator<<(std::wostream& ostr, const Exception& e)
{
    ostr << e.toString();
    return ostr;
}



}
