/* lw-support/src/lib/Net/Address/Address.h
 *
 *  (c)2005, Laurence Withers. Released under the GNU GPL. See file
 *  COPYING for more information / terms of license.
*/

namespace lw {



/*! \brief Base class for network addresses.

Since network addresses are used in very different ways, this class
doesn't provide much of an interface. However, it does allow for
dynamic casting, which is its main purpose.

*/
class NetAddress {
public:
    /// Destructor. Does nothing.
    virtual ~NetAddress()
    { }

    /// Convert to std::string representation
    virtual std::wstring toString() const = 0;

    /// Clone address.
    virtual NetAddress* clone() const = 0;
};



/// Stream insertion operator.
std::wostream& operator<<(std::wostream&, const lw::NetAddress&);



}
