/* lw-support/src/lib/Net/Client.h
 *
 *  (c)2005, Laurence Withers. Released under the GNU GPL. See file
 *  COPYING for more information / terms of license.
*/

namespace lw {



/*! \brief Base class for network clients.

This class contains some common functionality shared by all network
socket clients.

*/
class NetClient : public IOPosixDevice {
public:
    // implemented virtuals
    virtual void checkErrors();



    /*! \brief Shut down part of a connection.

    \param read Set to \a true if you want to shut down reading.
    \param write Set to \a true if you want to shut down writing.
    \throws IOModeError if the socket is not connected.
    \throws SystemError if a system error occurs.

    This allows you to shut down part of a connection; either reading or
    writing (or possibly both). Any data waiting to be received or
    transmitted is discarded, and the read or write operation becomes
    unavailable (the I/O mode is changed to reflect this).

    */
    virtual void shutdown(bool read, bool write);
};



}
