/* lw-support/src/lib/Net/TCP/Server.h
 *
 *  (c)2005, Laurence Withers. Released under the GNU GPL. See file
 *  COPYING for more information / terms of license.
*/

namespace lw {



/*! \brief TCP server class.

\todo docs

*/
class NetServerTCP : public NetServer {
public:
    /// Constructor. Does not open connection.
    NetServerTCP()
    { }



    /*! \brief Begin listening on a specific address.

    \param address The address to listen on.
    \param port The port number to listen on.
    \param queueLen The length of the unaccepted connection queue.
    \throws SystemError if a system error occurs.

    This function starts the server listening for new connections. The
    server will listen on any address.

    */
    void listen(const NetAddress& address, uint16_t port, int queueLen);



    /*! \brief Stop listening to incoming connections.

    \throws SystemError if a system error occurs.

    This function will stop listening for incoming connections, and will
    reject any connection requests that have not yet been accepted.

    */
    void stop();



    //BEGIN // Implemented virtuals ////////////////////////////////////

    virtual lw::NetClientTCP* accept();
    virtual lw::NetClientTCP* acceptBlocking(int timeout, IOTimeoutMode timeoutMode);
};



}
