/* lw-support/src/lib/Thread/Mutex.cpp
 *
 *  (c)2005, Laurence Withers. Released under the GNU GPL. See file
 *  COPYING for more information / terms of license.
*/

namespace lw {



Mutex::Mutex(bool recursive)
{
// note the function calls here always succeed
    // tell pthreads we want a "normal" (simple) mutex
    pthread_mutexattr_t attr;
    pthread_mutexattr_init(&attr);
    if(recursive) pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE);
    else pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_NORMAL);

    // initialise the mutex
    pthread_mutex_init(&mut, &attr);

    // clean up
    pthread_mutexattr_destroy(&attr);
}



Mutex::~Mutex()
{
    // destroy the mutex
    pthread_mutex_destroy(&mut);
}



}
