/* lw-support/src/lib/Time/StopWatch.cpp
 *
 *  (c)2005, Laurence Withers. Released under the GNU GPL. See file
 *  COPYING for more information / terms of license.
*/

namespace lw {



StopWatch::StopWatch()
    : hasStarted(true)
{
    if(clock_gettime(CLOCK_REALTIME, &started)) throw SystemError();
}



void StopWatch::start()
{
    hasStarted = true;
    if(clock_gettime(CLOCK_REALTIME, &started)) throw SystemError();
}



void StopWatch::stop()
{
    hasStarted = false;
    if(clock_gettime(CLOCK_REALTIME, &stopped)) throw SystemError();
}



ElapsedTime StopWatch::elapsed() const
{
    if(hasStarted && clock_gettime(CLOCK_REALTIME, &stopped))
        throw SystemError();
    return ElapsedTime::from_ns((uint64_t)((stopped.tv_sec - started.tv_sec) * tenExp9
        + (stopped.tv_nsec - started.tv_nsec)));
}



}
