/* lw-support/src/lib/Util/Key.cpp
 *
 *  (c)2005, Laurence Withers. Released under the GNU GPL. See file
 *  COPYING for more information / terms of license.
*/

namespace lw {

Key::keyType Key::globalKey = 0;



std::wstring Key::toString() const
{
    std::wostringstream str;

    str << L"{KEY{!"
        << key
        << L"}}";

    return str.str();
}



lw::Key Key::fromString(const std::wstring& strIn)
{
    std::wstring str = stripWhitespace(strIn);
    std::wstring::size_type end = str.size();

    if(end < 9 || str.substr(0, 6) != L"!KEY{!" || str.substr(end - 2, 2) != L"}}")
        throw ParseError(L"Not a valid key.", str, 0);
    return Key(strToUInt64(str.substr(6, end - 8)));
}



}
